
_Display_Temperature:

;DS18B20.c,8 :: 		void Display_Temperature(unsigned int temp2write) {
;DS18B20.c,12 :: 		if (temp2write & 0x8000) {  //check if temperature is negative.
	BST        R3, 7
	BRTS       L__Display_Temperature18
	JMP        L_Display_Temperature0
L__Display_Temperature18:
;DS18B20.c,13 :: 		temp2write = ~temp2write + 1;   // if the temperature is negative.
	MOVW       R16, R2
	COM        R16
	COM        R17
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R2, R16
;DS18B20.c,14 :: 		aux=1;
	LDI        R27, 1
	STS        _aux+0, R27
;DS18B20.c,15 :: 		}
	JMP        L_Display_Temperature1
L_Display_Temperature0:
;DS18B20.c,16 :: 		else   aux=0; // if the temperature is positive.
	LDI        R27, 0
	STS        _aux+0, R27
L_Display_Temperature1:
;DS18B20.c,17 :: 		temp2 = temp2write >> RES_SHIFT ;
	MOVW       R16, R2
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	LSR        R17
	ROR        R16
	STS        _temp2+0, R16
;DS18B20.c,18 :: 		}
L_end_Display_Temperature:
	RET
; end of _Display_Temperature

_set_up:

;DS18B20.c,19 :: 		void set_up() {    //Configuration for Pic16F887
;DS18B20.c,21 :: 		DDRC  = 0xFF;   // Pin.C7 , Pin.C6 and Pin.C5  set up as inputs
	LDI        R27, 255
	OUT        DDRC+0, R27
;DS18B20.c,22 :: 		DDRD  = 0xFF;   // Pin.C7 , Pin.C6 and Pin.C5  set up as inputs
	LDI        R27, 255
	OUT        DDRD+0, R27
;DS18B20.c,23 :: 		DDB1_bit = 1;
	IN         R27, DDB1_bit+0
	SBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;DS18B20.c,24 :: 		PORTC = 0;   // set clear to port C
	LDI        R27, 0
	OUT        PORTC+0, R27
;DS18B20.c,25 :: 		PORTD = 0;
	LDI        R27, 0
	OUT        PORTD+0, R27
;DS18B20.c,26 :: 		PORTB.b1 = 0;
	IN         R27, PORTB+0
	CBR        R27, 2
	OUT        PORTB+0, R27
;DS18B20.c,28 :: 		}
L_end_set_up:
	RET
; end of _set_up

_Print_temp:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 10
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;DS18B20.c,29 :: 		void  Print_temp() {
;DS18B20.c,32 :: 		short int i=0;
;DS18B20.c,33 :: 		unsigned char display[10] = {0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x67};
	LDI        R30, #lo_addr(?ICSPrint_temp_display_L0+0)
	LDI        R31, hi_addr(?ICSPrint_temp_display_L0+0)
	MOVW       R26, R28
	LDI        R24, 10
	LDI        R25, 0
	CALL       ___CC2DW+0
;DS18B20.c,35 :: 		for (i=0; i<=90; i++) { //for to stabilize the changes of temperature
; i start address is: 19 (R19)
	LDI        R19, 0
; i end address is: 19 (R19)
L_Print_temp2:
; i start address is: 19 (R19)
	LDI        R16, 90
	CP         R16, R19
	BRGE       L__Print_temp21
	JMP        L_Print_temp3
L__Print_temp21:
;DS18B20.c,36 :: 		ch0 = temp2/100;
	LDS        R16, _temp2+0
	LDI        R20, 100
	CALL       _Div_8x8_U+0
;DS18B20.c,37 :: 		PORTC = 1;              //
	LDI        R27, 1
	OUT        PORTC+0, R27
;DS18B20.c,38 :: 		PORTD = display[ch0] ;
	MOV        R17, R28
	MOV        R18, R29
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LD         R16, Z
	OUT        PORTD+0, R16
;DS18B20.c,39 :: 		delay_ms(2);
	LDI        R17, 21
	LDI        R16, 199
L_Print_temp5:
	DEC        R16
	BRNE       L_Print_temp5
	DEC        R17
	BRNE       L_Print_temp5
;DS18B20.c,40 :: 		ch1 = (temp2/10) % 10;
	LDS        R16, _temp2+0
	LDI        R20, 10
	CALL       _Div_8x8_U+0
	LDI        R20, 10
	CALL       _Div_8x8_U+0
	MOV        R16, R25
;DS18B20.c,41 :: 		PORTC = 2;             //
	LDI        R27, 2
	OUT        PORTC+0, R27
;DS18B20.c,42 :: 		PORTD = display[ch1] ;
	MOV        R17, R28
	MOV        R18, R29
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LD         R16, Z
	OUT        PORTD+0, R16
;DS18B20.c,43 :: 		delay_ms(2);
	LDI        R17, 21
	LDI        R16, 199
L_Print_temp7:
	DEC        R16
	BRNE       L_Print_temp7
	DEC        R17
	BRNE       L_Print_temp7
;DS18B20.c,44 :: 		ch2 = temp2 % 10;
	LDS        R16, _temp2+0
	LDI        R20, 10
	CALL       _Div_8x8_U+0
	MOV        R16, R25
;DS18B20.c,45 :: 		PORTC = 4;             //
	LDI        R27, 4
	OUT        PORTC+0, R27
;DS18B20.c,46 :: 		PORTD = display[ch2];
	MOV        R17, R28
	MOV        R18, R29
	MOV        R30, R16
	LDI        R31, 0
	ADD        R30, R17
	ADC        R31, R18
	LD         R16, Z
	OUT        PORTD+0, R16
;DS18B20.c,47 :: 		delay_ms(2);
	LDI        R17, 21
	LDI        R16, 199
L_Print_temp9:
	DEC        R16
	BRNE       L_Print_temp9
	DEC        R17
	BRNE       L_Print_temp9
;DS18B20.c,35 :: 		for (i=0; i<=90; i++) { //for to stabilize the changes of temperature
	MOV        R16, R19
	SUBI       R16, 255
	MOV        R19, R16
;DS18B20.c,48 :: 		}
; i end address is: 19 (R19)
	JMP        L_Print_temp2
L_Print_temp3:
;DS18B20.c,49 :: 		}
L_end_Print_temp:
	ADIW       R28, 9
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _Print_temp

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;DS18B20.c,50 :: 		void main() {
;DS18B20.c,51 :: 		set_up();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _set_up+0
;DS18B20.c,52 :: 		while (1){
L_main11:
;DS18B20.c,53 :: 		Ow_Reset(&PORTB, 2);                        // Onewire reset signal
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Reset+0
;DS18B20.c,54 :: 		Ow_Write(&PORTB, 2, 0xCC);                  // Issue command SKIP_ROM
	LDI        R27, 204
	MOV        R5, R27
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Write+0
;DS18B20.c,55 :: 		Ow_Write(&PORTB, 2, 0x44);                  // Issue command CONVERT_T
	LDI        R27, 68
	MOV        R5, R27
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Write+0
;DS18B20.c,56 :: 		Delay_us(120);
	LDI        R17, 2
	LDI        R16, 62
L_main13:
	DEC        R16
	BRNE       L_main13
	DEC        R17
	BRNE       L_main13
	NOP
;DS18B20.c,57 :: 		Ow_Reset(&PORTB, 2);
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Reset+0
;DS18B20.c,58 :: 		Ow_Write(&PORTB, 2, 0xCC);                  // Issue command SKIP_ROM
	LDI        R27, 204
	MOV        R5, R27
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Write+0
;DS18B20.c,59 :: 		Ow_Write(&PORTB, 2, 0xBE);                  // Issue command READ_SCRATCHPAD
	LDI        R27, 190
	MOV        R5, R27
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Write+0
;DS18B20.c,60 :: 		temp1 =  Ow_Read(&PORTB, 2);
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Read+0
	STS        _temp1+0, R16
	LDI        R27, 0
	STS        _temp1+1, R27
;DS18B20.c,61 :: 		temp1 = (Ow_Read(&PORTB, 2) << 8) + temp1;
	LDI        R27, 2
	MOV        R4, R27
	LDI        R27, #lo_addr(PORTB+0)
	MOV        R2, R27
	LDI        R27, hi_addr(PORTB+0)
	MOV        R3, R27
	CALL       _Ow_Read+0
	MOV        R19, R16
	CLR        R18
	LDS        R16, _temp1+0
	LDS        R17, _temp1+1
	ADD        R16, R18
	ADC        R17, R19
	STS        _temp1+0, R16
	STS        _temp1+1, R17
;DS18B20.c,62 :: 		Display_Temperature(temp1);  // call the function to show temp2.
	MOVW       R2, R16
	CALL       _Display_Temperature+0
;DS18B20.c,63 :: 		Print_temp();
	CALL       _Print_temp+0
;DS18B20.c,64 :: 		if(aux==1) PORTB.b1 = 1;
	LDS        R16, _aux+0
	CPI        R16, 1
	BREQ       L__main23
	JMP        L_main15
L__main23:
	IN         R27, PORTB+0
	SBR        R27, 2
	OUT        PORTB+0, R27
	JMP        L_main16
L_main15:
;DS18B20.c,65 :: 		else       PORTB.b1 = 0;
	IN         R27, PORTB+0
	CBR        R27, 2
	OUT        PORTB+0, R27
L_main16:
;DS18B20.c,66 :: 		}
	JMP        L_main11
;DS18B20.c,67 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
